"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorFromName = exports.errorFromCode = exports.OperationNotFoundError = exports.NameTooLongError = exports.RuleSetOwnerMismatchError = exports.MissingPayloadValueError = exports.MissingAccountError = exports.MessagePackDeserializationErrorError = exports.DataIsEmptyError = exports.ValueOccupiedError = exports.BorshSerializationErrorError = exports.NotImplementedError = exports.PayerIsNotSignerError = exports.PubkeyTreeMatchCheckFailedError = exports.FrequencyCheckFailedError = exports.AmountCheckFailedError = exports.ProgramOwnedCheckFailedError = exports.DerivedKeyMatchCheckFailedError = exports.PubkeyMatchCheckFailedError = exports.AdditionalSignerCheckFailedError = exports.DerivedKeyInvalidError = exports.PayloadVecIndexErrorError = exports.IncorrectOwnerError = exports.DataTypeMismatchError = exports.NumericalOverflowError = void 0;
const createErrorFromCodeLookup = new Map();
const createErrorFromNameLookup = new Map();
class NumericalOverflowError extends Error {
    constructor() {
        super('Numerical Overflow');
        this.code = 0x0;
        this.name = 'NumericalOverflow';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, NumericalOverflowError);
        }
    }
}
exports.NumericalOverflowError = NumericalOverflowError;
createErrorFromCodeLookup.set(0x0, () => new NumericalOverflowError());
createErrorFromNameLookup.set('NumericalOverflow', () => new NumericalOverflowError());
class DataTypeMismatchError extends Error {
    constructor() {
        super('Data type mismatch');
        this.code = 0x1;
        this.name = 'DataTypeMismatch';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, DataTypeMismatchError);
        }
    }
}
exports.DataTypeMismatchError = DataTypeMismatchError;
createErrorFromCodeLookup.set(0x1, () => new DataTypeMismatchError());
createErrorFromNameLookup.set('DataTypeMismatch', () => new DataTypeMismatchError());
class IncorrectOwnerError extends Error {
    constructor() {
        super('Incorrect account owner');
        this.code = 0x2;
        this.name = 'IncorrectOwner';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, IncorrectOwnerError);
        }
    }
}
exports.IncorrectOwnerError = IncorrectOwnerError;
createErrorFromCodeLookup.set(0x2, () => new IncorrectOwnerError());
createErrorFromNameLookup.set('IncorrectOwner', () => new IncorrectOwnerError());
class PayloadVecIndexErrorError extends Error {
    constructor() {
        super('Could not index into PayloadVec');
        this.code = 0x3;
        this.name = 'PayloadVecIndexError';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, PayloadVecIndexErrorError);
        }
    }
}
exports.PayloadVecIndexErrorError = PayloadVecIndexErrorError;
createErrorFromCodeLookup.set(0x3, () => new PayloadVecIndexErrorError());
createErrorFromNameLookup.set('PayloadVecIndexError', () => new PayloadVecIndexErrorError());
class DerivedKeyInvalidError extends Error {
    constructor() {
        super('Derived key invalid');
        this.code = 0x4;
        this.name = 'DerivedKeyInvalid';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, DerivedKeyInvalidError);
        }
    }
}
exports.DerivedKeyInvalidError = DerivedKeyInvalidError;
createErrorFromCodeLookup.set(0x4, () => new DerivedKeyInvalidError());
createErrorFromNameLookup.set('DerivedKeyInvalid', () => new DerivedKeyInvalidError());
class AdditionalSignerCheckFailedError extends Error {
    constructor() {
        super('Additional Signer check failed');
        this.code = 0x5;
        this.name = 'AdditionalSignerCheckFailed';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, AdditionalSignerCheckFailedError);
        }
    }
}
exports.AdditionalSignerCheckFailedError = AdditionalSignerCheckFailedError;
createErrorFromCodeLookup.set(0x5, () => new AdditionalSignerCheckFailedError());
createErrorFromNameLookup.set('AdditionalSignerCheckFailed', () => new AdditionalSignerCheckFailedError());
class PubkeyMatchCheckFailedError extends Error {
    constructor() {
        super('Pubkey Match check failed');
        this.code = 0x6;
        this.name = 'PubkeyMatchCheckFailed';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, PubkeyMatchCheckFailedError);
        }
    }
}
exports.PubkeyMatchCheckFailedError = PubkeyMatchCheckFailedError;
createErrorFromCodeLookup.set(0x6, () => new PubkeyMatchCheckFailedError());
createErrorFromNameLookup.set('PubkeyMatchCheckFailed', () => new PubkeyMatchCheckFailedError());
class DerivedKeyMatchCheckFailedError extends Error {
    constructor() {
        super('Derived Key Match check failed');
        this.code = 0x7;
        this.name = 'DerivedKeyMatchCheckFailed';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, DerivedKeyMatchCheckFailedError);
        }
    }
}
exports.DerivedKeyMatchCheckFailedError = DerivedKeyMatchCheckFailedError;
createErrorFromCodeLookup.set(0x7, () => new DerivedKeyMatchCheckFailedError());
createErrorFromNameLookup.set('DerivedKeyMatchCheckFailed', () => new DerivedKeyMatchCheckFailedError());
class ProgramOwnedCheckFailedError extends Error {
    constructor() {
        super('Program Owned check failed');
        this.code = 0x8;
        this.name = 'ProgramOwnedCheckFailed';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, ProgramOwnedCheckFailedError);
        }
    }
}
exports.ProgramOwnedCheckFailedError = ProgramOwnedCheckFailedError;
createErrorFromCodeLookup.set(0x8, () => new ProgramOwnedCheckFailedError());
createErrorFromNameLookup.set('ProgramOwnedCheckFailed', () => new ProgramOwnedCheckFailedError());
class AmountCheckFailedError extends Error {
    constructor() {
        super('Amount checked failed');
        this.code = 0x9;
        this.name = 'AmountCheckFailed';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, AmountCheckFailedError);
        }
    }
}
exports.AmountCheckFailedError = AmountCheckFailedError;
createErrorFromCodeLookup.set(0x9, () => new AmountCheckFailedError());
createErrorFromNameLookup.set('AmountCheckFailed', () => new AmountCheckFailedError());
class FrequencyCheckFailedError extends Error {
    constructor() {
        super('Frequency check failed');
        this.code = 0xa;
        this.name = 'FrequencyCheckFailed';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, FrequencyCheckFailedError);
        }
    }
}
exports.FrequencyCheckFailedError = FrequencyCheckFailedError;
createErrorFromCodeLookup.set(0xa, () => new FrequencyCheckFailedError());
createErrorFromNameLookup.set('FrequencyCheckFailed', () => new FrequencyCheckFailedError());
class PubkeyTreeMatchCheckFailedError extends Error {
    constructor() {
        super('Pubkey Tree Match check failed');
        this.code = 0xb;
        this.name = 'PubkeyTreeMatchCheckFailed';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, PubkeyTreeMatchCheckFailedError);
        }
    }
}
exports.PubkeyTreeMatchCheckFailedError = PubkeyTreeMatchCheckFailedError;
createErrorFromCodeLookup.set(0xb, () => new PubkeyTreeMatchCheckFailedError());
createErrorFromNameLookup.set('PubkeyTreeMatchCheckFailed', () => new PubkeyTreeMatchCheckFailedError());
class PayerIsNotSignerError extends Error {
    constructor() {
        super('Payer is not a signer');
        this.code = 0xc;
        this.name = 'PayerIsNotSigner';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, PayerIsNotSignerError);
        }
    }
}
exports.PayerIsNotSignerError = PayerIsNotSignerError;
createErrorFromCodeLookup.set(0xc, () => new PayerIsNotSignerError());
createErrorFromNameLookup.set('PayerIsNotSigner', () => new PayerIsNotSignerError());
class NotImplementedError extends Error {
    constructor() {
        super('Not implemented');
        this.code = 0xd;
        this.name = 'NotImplemented';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, NotImplementedError);
        }
    }
}
exports.NotImplementedError = NotImplementedError;
createErrorFromCodeLookup.set(0xd, () => new NotImplementedError());
createErrorFromNameLookup.set('NotImplemented', () => new NotImplementedError());
class BorshSerializationErrorError extends Error {
    constructor() {
        super('Borsh serialization error');
        this.code = 0xe;
        this.name = 'BorshSerializationError';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, BorshSerializationErrorError);
        }
    }
}
exports.BorshSerializationErrorError = BorshSerializationErrorError;
createErrorFromCodeLookup.set(0xe, () => new BorshSerializationErrorError());
createErrorFromNameLookup.set('BorshSerializationError', () => new BorshSerializationErrorError());
class ValueOccupiedError extends Error {
    constructor() {
        super('Value in Payload or RuleSet is occupied');
        this.code = 0xf;
        this.name = 'ValueOccupied';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, ValueOccupiedError);
        }
    }
}
exports.ValueOccupiedError = ValueOccupiedError;
createErrorFromCodeLookup.set(0xf, () => new ValueOccupiedError());
createErrorFromNameLookup.set('ValueOccupied', () => new ValueOccupiedError());
class DataIsEmptyError extends Error {
    constructor() {
        super('Account data is empty');
        this.code = 0x10;
        this.name = 'DataIsEmpty';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, DataIsEmptyError);
        }
    }
}
exports.DataIsEmptyError = DataIsEmptyError;
createErrorFromCodeLookup.set(0x10, () => new DataIsEmptyError());
createErrorFromNameLookup.set('DataIsEmpty', () => new DataIsEmptyError());
class MessagePackDeserializationErrorError extends Error {
    constructor() {
        super('MessagePack deserialization error');
        this.code = 0x11;
        this.name = 'MessagePackDeserializationError';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, MessagePackDeserializationErrorError);
        }
    }
}
exports.MessagePackDeserializationErrorError = MessagePackDeserializationErrorError;
createErrorFromCodeLookup.set(0x11, () => new MessagePackDeserializationErrorError());
createErrorFromNameLookup.set('MessagePackDeserializationError', () => new MessagePackDeserializationErrorError());
class MissingAccountError extends Error {
    constructor() {
        super('Missing account');
        this.code = 0x12;
        this.name = 'MissingAccount';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, MissingAccountError);
        }
    }
}
exports.MissingAccountError = MissingAccountError;
createErrorFromCodeLookup.set(0x12, () => new MissingAccountError());
createErrorFromNameLookup.set('MissingAccount', () => new MissingAccountError());
class MissingPayloadValueError extends Error {
    constructor() {
        super('Missing Payload value');
        this.code = 0x13;
        this.name = 'MissingPayloadValue';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, MissingPayloadValueError);
        }
    }
}
exports.MissingPayloadValueError = MissingPayloadValueError;
createErrorFromCodeLookup.set(0x13, () => new MissingPayloadValueError());
createErrorFromNameLookup.set('MissingPayloadValue', () => new MissingPayloadValueError());
class RuleSetOwnerMismatchError extends Error {
    constructor() {
        super('RuleSet owner must be payer');
        this.code = 0x14;
        this.name = 'RuleSetOwnerMismatch';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, RuleSetOwnerMismatchError);
        }
    }
}
exports.RuleSetOwnerMismatchError = RuleSetOwnerMismatchError;
createErrorFromCodeLookup.set(0x14, () => new RuleSetOwnerMismatchError());
createErrorFromNameLookup.set('RuleSetOwnerMismatch', () => new RuleSetOwnerMismatchError());
class NameTooLongError extends Error {
    constructor() {
        super('Name too long');
        this.code = 0x15;
        this.name = 'NameTooLong';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, NameTooLongError);
        }
    }
}
exports.NameTooLongError = NameTooLongError;
createErrorFromCodeLookup.set(0x15, () => new NameTooLongError());
createErrorFromNameLookup.set('NameTooLong', () => new NameTooLongError());
class OperationNotFoundError extends Error {
    constructor() {
        super('The operation retrieved is not in the selected RuleSet');
        this.code = 0x16;
        this.name = 'OperationNotFound';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, OperationNotFoundError);
        }
    }
}
exports.OperationNotFoundError = OperationNotFoundError;
createErrorFromCodeLookup.set(0x16, () => new OperationNotFoundError());
createErrorFromNameLookup.set('OperationNotFound', () => new OperationNotFoundError());
function errorFromCode(code) {
    const createError = createErrorFromCodeLookup.get(code);
    return createError != null ? createError() : null;
}
exports.errorFromCode = errorFromCode;
function errorFromName(name) {
    const createError = createErrorFromNameLookup.get(name);
    return createError != null ? createError() : null;
}
exports.errorFromName = errorFromName;
//# sourceMappingURL=index.js.map