import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
import { CreateArgs } from '../types/CreateArgs';
export type CreateInstructionArgs = {
    createArgs: CreateArgs;
};
export declare const CreateStruct: beet.FixableBeetArgsStruct<CreateInstructionArgs & {
    instructionDiscriminator: number;
}>;
export type CreateInstructionAccounts = {
    payer: web3.PublicKey;
    ruleSetPda: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    optRulePda1?: web3.PublicKey;
    optRulePda2?: web3.PublicKey;
    optRulePda3?: web3.PublicKey;
    optRulePda4?: web3.PublicKey;
    optRulePda5?: web3.PublicKey;
};
export declare const createInstructionDiscriminator = 0;
export declare function createCreateInstruction(accounts: CreateInstructionAccounts, args: CreateInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
