"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createCreateInstruction = exports.createInstructionDiscriminator = exports.CreateStruct = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const web3 = __importStar(require("@solana/web3.js"));
const CreateArgs_1 = require("../types/CreateArgs");
exports.CreateStruct = new beet.FixableBeetArgsStruct([
    ['instructionDiscriminator', beet.u8],
    ['createArgs', CreateArgs_1.createArgsBeet],
], 'CreateInstructionArgs');
exports.createInstructionDiscriminator = 0;
function createCreateInstruction(accounts, args, programId = new web3.PublicKey('auth9SigNpDKz4sJJ1DfCTuZrZNSAgh9sFD3rboVmgg')) {
    var _a;
    const [data] = exports.CreateStruct.serialize({
        instructionDiscriminator: exports.createInstructionDiscriminator,
        ...args,
    });
    const keys = [
        {
            pubkey: accounts.payer,
            isWritable: true,
            isSigner: true,
        },
        {
            pubkey: accounts.ruleSetPda,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: (_a = accounts.systemProgram) !== null && _a !== void 0 ? _a : web3.SystemProgram.programId,
            isWritable: false,
            isSigner: false,
        },
    ];
    if (accounts.optRulePda1 != null) {
        keys.push({
            pubkey: accounts.optRulePda1,
            isWritable: false,
            isSigner: false,
        });
    }
    if (accounts.optRulePda2 != null) {
        if (accounts.optRulePda1 == null) {
            throw new Error("When providing 'optRulePda2' then 'accounts.optRulePda1' need(s) to be provided as well.");
        }
        keys.push({
            pubkey: accounts.optRulePda2,
            isWritable: false,
            isSigner: false,
        });
    }
    if (accounts.optRulePda3 != null) {
        if (accounts.optRulePda1 == null || accounts.optRulePda2 == null) {
            throw new Error("When providing 'optRulePda3' then 'accounts.optRulePda1', 'accounts.optRulePda2' need(s) to be provided as well.");
        }
        keys.push({
            pubkey: accounts.optRulePda3,
            isWritable: false,
            isSigner: false,
        });
    }
    if (accounts.optRulePda4 != null) {
        if (accounts.optRulePda1 == null ||
            accounts.optRulePda2 == null ||
            accounts.optRulePda3 == null) {
            throw new Error("When providing 'optRulePda4' then 'accounts.optRulePda1', 'accounts.optRulePda2', 'accounts.optRulePda3' need(s) to be provided as well.");
        }
        keys.push({
            pubkey: accounts.optRulePda4,
            isWritable: false,
            isSigner: false,
        });
    }
    if (accounts.optRulePda5 != null) {
        if (accounts.optRulePda1 == null ||
            accounts.optRulePda2 == null ||
            accounts.optRulePda3 == null ||
            accounts.optRulePda4 == null) {
            throw new Error("When providing 'optRulePda5' then 'accounts.optRulePda1', 'accounts.optRulePda2', 'accounts.optRulePda3', 'accounts.optRulePda4' need(s) to be provided as well.");
        }
        keys.push({
            pubkey: accounts.optRulePda5,
            isWritable: false,
            isSigner: false,
        });
    }
    const ix = new web3.TransactionInstruction({
        programId,
        keys,
        data,
    });
    return ix;
}
exports.createCreateInstruction = createCreateInstruction;
//# sourceMappingURL=Create.js.map