import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
import { ValidateArgs } from '../types/ValidateArgs';
export type ValidateInstructionArgs = {
    validateArgs: ValidateArgs;
};
export declare const ValidateStruct: beet.FixableBeetArgsStruct<ValidateInstructionArgs & {
    instructionDiscriminator: number;
}>;
export type ValidateInstructionAccounts = {
    ruleSet: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    optRuleSigner1?: web3.PublicKey;
    optRuleSigner2?: web3.PublicKey;
    optRuleSigner3?: web3.PublicKey;
    optRuleSigner4?: web3.PublicKey;
    optRuleSigner5?: web3.PublicKey;
    optRuleNonsigner1?: web3.PublicKey;
    optRuleNonsigner2?: web3.PublicKey;
    optRuleNonsigner3?: web3.PublicKey;
    optRuleNonsigner4?: web3.PublicKey;
    optRuleNonsigner5?: web3.PublicKey;
};
export declare const validateInstructionDiscriminator = 1;
export declare function createValidateInstruction(accounts: ValidateInstructionAccounts, args: ValidateInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
