"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createValidateInstruction = exports.validateInstructionDiscriminator = exports.ValidateStruct = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const web3 = __importStar(require("@solana/web3.js"));
const ValidateArgs_1 = require("../types/ValidateArgs");
exports.ValidateStruct = new beet.FixableBeetArgsStruct([
    ['instructionDiscriminator', beet.u8],
    ['validateArgs', ValidateArgs_1.validateArgsBeet],
], 'ValidateInstructionArgs');
exports.validateInstructionDiscriminator = 1;
function createValidateInstruction(accounts, args, programId = new web3.PublicKey('auth9SigNpDKz4sJJ1DfCTuZrZNSAgh9sFD3rboVmgg')) {
    var _a;
    const [data] = exports.ValidateStruct.serialize({
        instructionDiscriminator: exports.validateInstructionDiscriminator,
        ...args,
    });
    const keys = [
        {
            pubkey: accounts.ruleSet,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: (_a = accounts.systemProgram) !== null && _a !== void 0 ? _a : web3.SystemProgram.programId,
            isWritable: false,
            isSigner: false,
        },
    ];
    if (accounts.optRuleSigner1 != null) {
        keys.push({
            pubkey: accounts.optRuleSigner1,
            isWritable: false,
            isSigner: true,
        });
    }
    if (accounts.optRuleSigner2 != null) {
        if (accounts.optRuleSigner1 == null) {
            throw new Error("When providing 'optRuleSigner2' then 'accounts.optRuleSigner1' need(s) to be provided as well.");
        }
        keys.push({
            pubkey: accounts.optRuleSigner2,
            isWritable: false,
            isSigner: true,
        });
    }
    if (accounts.optRuleSigner3 != null) {
        if (accounts.optRuleSigner1 == null || accounts.optRuleSigner2 == null) {
            throw new Error("When providing 'optRuleSigner3' then 'accounts.optRuleSigner1', 'accounts.optRuleSigner2' need(s) to be provided as well.");
        }
        keys.push({
            pubkey: accounts.optRuleSigner3,
            isWritable: false,
            isSigner: true,
        });
    }
    if (accounts.optRuleSigner4 != null) {
        if (accounts.optRuleSigner1 == null ||
            accounts.optRuleSigner2 == null ||
            accounts.optRuleSigner3 == null) {
            throw new Error("When providing 'optRuleSigner4' then 'accounts.optRuleSigner1', 'accounts.optRuleSigner2', 'accounts.optRuleSigner3' need(s) to be provided as well.");
        }
        keys.push({
            pubkey: accounts.optRuleSigner4,
            isWritable: false,
            isSigner: true,
        });
    }
    if (accounts.optRuleSigner5 != null) {
        if (accounts.optRuleSigner1 == null ||
            accounts.optRuleSigner2 == null ||
            accounts.optRuleSigner3 == null ||
            accounts.optRuleSigner4 == null) {
            throw new Error("When providing 'optRuleSigner5' then 'accounts.optRuleSigner1', 'accounts.optRuleSigner2', 'accounts.optRuleSigner3', 'accounts.optRuleSigner4' need(s) to be provided as well.");
        }
        keys.push({
            pubkey: accounts.optRuleSigner5,
            isWritable: false,
            isSigner: true,
        });
    }
    if (accounts.optRuleNonsigner1 != null) {
        if (accounts.optRuleSigner1 == null ||
            accounts.optRuleSigner2 == null ||
            accounts.optRuleSigner3 == null ||
            accounts.optRuleSigner4 == null ||
            accounts.optRuleSigner5 == null) {
            throw new Error("When providing 'optRuleNonsigner1' then 'accounts.optRuleSigner1', 'accounts.optRuleSigner2', 'accounts.optRuleSigner3', 'accounts.optRuleSigner4', 'accounts.optRuleSigner5' need(s) to be provided as well.");
        }
        keys.push({
            pubkey: accounts.optRuleNonsigner1,
            isWritable: false,
            isSigner: false,
        });
    }
    if (accounts.optRuleNonsigner2 != null) {
        if (accounts.optRuleSigner1 == null ||
            accounts.optRuleSigner2 == null ||
            accounts.optRuleSigner3 == null ||
            accounts.optRuleSigner4 == null ||
            accounts.optRuleSigner5 == null ||
            accounts.optRuleNonsigner1 == null) {
            throw new Error("When providing 'optRuleNonsigner2' then 'accounts.optRuleSigner1', 'accounts.optRuleSigner2', 'accounts.optRuleSigner3', 'accounts.optRuleSigner4', 'accounts.optRuleSigner5', 'accounts.optRuleNonsigner1' need(s) to be provided as well.");
        }
        keys.push({
            pubkey: accounts.optRuleNonsigner2,
            isWritable: false,
            isSigner: false,
        });
    }
    if (accounts.optRuleNonsigner3 != null) {
        if (accounts.optRuleSigner1 == null ||
            accounts.optRuleSigner2 == null ||
            accounts.optRuleSigner3 == null ||
            accounts.optRuleSigner4 == null ||
            accounts.optRuleSigner5 == null ||
            accounts.optRuleNonsigner1 == null ||
            accounts.optRuleNonsigner2 == null) {
            throw new Error("When providing 'optRuleNonsigner3' then 'accounts.optRuleSigner1', 'accounts.optRuleSigner2', 'accounts.optRuleSigner3', 'accounts.optRuleSigner4', 'accounts.optRuleSigner5', 'accounts.optRuleNonsigner1', 'accounts.optRuleNonsigner2' need(s) to be provided as well.");
        }
        keys.push({
            pubkey: accounts.optRuleNonsigner3,
            isWritable: false,
            isSigner: false,
        });
    }
    if (accounts.optRuleNonsigner4 != null) {
        if (accounts.optRuleSigner1 == null ||
            accounts.optRuleSigner2 == null ||
            accounts.optRuleSigner3 == null ||
            accounts.optRuleSigner4 == null ||
            accounts.optRuleSigner5 == null ||
            accounts.optRuleNonsigner1 == null ||
            accounts.optRuleNonsigner2 == null ||
            accounts.optRuleNonsigner3 == null) {
            throw new Error("When providing 'optRuleNonsigner4' then 'accounts.optRuleSigner1', 'accounts.optRuleSigner2', 'accounts.optRuleSigner3', 'accounts.optRuleSigner4', 'accounts.optRuleSigner5', 'accounts.optRuleNonsigner1', 'accounts.optRuleNonsigner2', 'accounts.optRuleNonsigner3' need(s) to be provided as well.");
        }
        keys.push({
            pubkey: accounts.optRuleNonsigner4,
            isWritable: false,
            isSigner: false,
        });
    }
    if (accounts.optRuleNonsigner5 != null) {
        if (accounts.optRuleSigner1 == null ||
            accounts.optRuleSigner2 == null ||
            accounts.optRuleSigner3 == null ||
            accounts.optRuleSigner4 == null ||
            accounts.optRuleSigner5 == null ||
            accounts.optRuleNonsigner1 == null ||
            accounts.optRuleNonsigner2 == null ||
            accounts.optRuleNonsigner3 == null ||
            accounts.optRuleNonsigner4 == null) {
            throw new Error("When providing 'optRuleNonsigner5' then 'accounts.optRuleSigner1', 'accounts.optRuleSigner2', 'accounts.optRuleSigner3', 'accounts.optRuleSigner4', 'accounts.optRuleSigner5', 'accounts.optRuleNonsigner1', 'accounts.optRuleNonsigner2', 'accounts.optRuleNonsigner3', 'accounts.optRuleNonsigner4' need(s) to be provided as well.");
        }
        keys.push({
            pubkey: accounts.optRuleNonsigner5,
            isWritable: false,
            isSigner: false,
        });
    }
    const ix = new web3.TransactionInstruction({
        programId,
        keys,
        data,
    });
    return ix;
}
exports.createValidateInstruction = createValidateInstruction;
//# sourceMappingURL=Validate.js.map